<?php
class ControllerPaymentiPayPaymentSoftware extends Controller {
	protected function index() {
		$this->language->load('payment/iPay_payment_software');
		
		$this->data['text_credit_card'] = $this->language->get('text_credit_card');
		$this->data['text_wait'] = $this->language->get('text_wait');
		
		$this->data['entry_cc_owner'] = $this->language->get('entry_cc_owner');
		$this->data['entry_cc_number'] = $this->language->get('entry_cc_number');
		$this->data['entry_cc_expire_date'] = $this->language->get('entry_cc_expire_date');
		$this->data['entry_cc_cvv2'] = $this->language->get('entry_cc_cvv2');
		
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
		
		$this->data['months'] = array();
		
		for ($i = 1; $i <= 12; $i++) {
			$this->data['months'][] = array(
				'text'  => strftime('%B', mktime(0, 0, 0, $i, 1, 2000)), 
				'value' => sprintf('%02d', $i)
			);
		}
		
		$today = getdate();

		$this->data['year_expire'] = array();

		for ($i = $today['year']; $i < $today['year'] + 11; $i++) {
			$this->data['year_expire'][] = array(
				'text'  => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)),
				'value' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)) 
			);
		}

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/iPay_payment_software.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/iPay_payment_software.tpl';
		} else {
			$this->template = 'default/template/payment/iPay_payment_software.tpl';
		}	
		
		$this->render();		
	}
	
	public function send() {
		$this->load->model('checkout/order');
		$curlval = 1;	//is curl val true?

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$request  = 'vendor_ref=' . urlencode('kiara');
		$request .= '&total=' . urlencode($order_info['total']);
		$request .= '&mpesa=' . urlencode(str_replace(' ', '', $this->request->post['mpesa']));
		$request .= '&zap=' . urlencode(str_replace(' ', '', $this->request->post['zap']));
		$request .= '&yu=' . urlencode(str_replace(' ', '', $this->request->post['yu']));
		$request .= '&phone1=' . urlencode($order_info['telephone']);
		$request .= '&email=' . urlencode($order_info['email']);
		$request .= '&order_id=' . urlencode($this->session->data['order_id']);
		$request .= '&invoice=' . urlencode($this->session->data['order_id']);
		$request .= '&curl='.$curlval;

	
		if ($this->config->get('iPay_payment_software_mode') == 'test') {
			$request .= '&TEST_MODE=1';
		}
		
		$curl = curl_init('https://ipay.intrepid.co.ke/incoming/');

		curl_setopt($curl, CURLOPT_PORT, 443);
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
		curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $request);

		$response = curl_exec($curl);
		
		curl_close($curl);
		
		//If in test mode strip results to only contain xml data
		if($this->config->get('iPay_payment_software_mode') == 'test'){
			$end_index = strpos($response, '</iPayPaymentSoftwareResponse>');
			$debug = substr($response, $end_index + 30);
			$response = substr($response, 0, $end_index)  .'</iPayPaymentSoftwareResponse>';
		}
		
		//get response string
		$response_array = explode(";", $response);	//explode the string into an array

		//create object to use as json
		$json = array();
		
		//If successful log transaction in opencart system
		if ('aex1ip' === $response_array[0]) {
			$this->model_checkout_order->confirm($this->session->data['order_id'], $this->config->get('config_order_status_id'));
			
			$message = '';
			
			$message .= 'Response Code: Your Payment Transaction was Successful';
			
			$this->model_checkout_order->update($this->session->data['order_id'], $this->config->get('iPay_payment_software_order_status_id'), $message, false);				
			
			$json['success'] = HTTPS_SERVER . 'index.php?route=checkout/success';
		} elseif ('pending' === $response_array[0]) {
			$json['error'] = "Your transaction cannot be processed at this time. Your order is still pending. Please try again in 5 minutes.";
		
		} elseif ('used' === $response_array[0]) {
			$json['error'] = "The transaction code you are trying to check out has already been used. Your order is still pending.";
		
		} elseif ('more' === $response_array[0]) {
			$this->model_checkout_order->confirm($this->session->data['order_id'], $this->config->get('config_order_status_id'));
			
			$message = '';
			
			$message .= 'Response Code: Your Payment Transaction was Successful';
			
			$this->model_checkout_order->update($this->session->data['order_id'], $this->config->get('iPay_payment_software_order_status_id'), $message, false);				
		
		} elseif ('less' === $response_array[0]) {
			$json['error'] = "Your transaction amount was LESS than what was checked out. Your order is still pending. Please try again in 5 minutes.";
		
		} else {
			$json['error'] = "Your transaction is still pending. Please try again in 5 minutes.";
		}
		
		$this->response->setOutput(json_encode($json));
	}
}
?>
